package com.googlecode.jpattern.service.transaction;

import com.googlecode.jpattern.core.IProvider;

/**
 * 
 * @author Francesco Cina'
 *
 * 28 Mar 2011
 */
public abstract class ATransactionManager {

	/**
	 * Begin of a new transaction
	 * @param provider the IProvider to use
	 * @return true if a new transaction is created; false if an existing transaction is found
	 */
	public abstract boolean beginTransaction(IProvider provider);
	
	public abstract void setForceReadOnly(boolean forceReadOnly);

	protected abstract void commit(IProvider provider);
	
	protected abstract void rollback(IProvider provider);

	public abstract void setForceNewTransaction(boolean forceNewTransaction);
	
	public abstract boolean isClosed();

	public abstract boolean isRollbackOnly();
	
}
